classdef EMtoKmeansClustering
    %
    %   Created by Jiann-Ming Wu on 10/23/18.
    %   Copyright © 2018 Jiann-Ming Wu. All rights reserved.
    %   Hierachical clustering
    %
    %   annealing EM to Kmeans for minimizing the mean distance of each data point to a center
    %   adusting the result derived by annealing EM
    %   UNTITLED Summary of this class goes here
    %   Detailed explanation goes here

    properties
        localCenters
        memberships
        meanDis
        withSourceData
        needAdjust
        sourceData
        twoLevel
        localCentersLevel2
    end
    
    methods
            function obj = EMtoKmeansClustering(X,K,withSourceData,needAdjust,twoLevel)
            %UNTITLED Construct an instance of this class
            %   Detailed explanation goes here
            obj.withSourceData = withSourceData;
            obj.needAdjust = needAdjust;
            if obj.withSourceData == 1
                obj.sourceData = X;
                obj=obj.annealed_kmeans2(K);

            end
            if obj.needAdjust == 1
                obj=obj.adjustSplitting();
                fprintf('adjusting... \n');
            end
            obj.twoLevel = twoLevel;
            if obj.twoLevel == 1
                % parallel codes for second-level clustering 
            end
        end
        
        function obj=annealed_kmeans2(obj,K)
            X=obj.sourceData;
            [N d]=size(X);
            mean_x = mean(X);
            B=0.005
            stability=1/K;
            kick = 10^-8;
            Y=rand(K,d)*kick-kick/2+ones(K,1)*mean_x;
            HC=0; Q=ceil(rand(N,1)*size(Y,1))';
            
            ep=10^-10; loop = 0;
            while ~HC
                loop = loop + 1;
                if stability < 1/K*1.00001
                    Y=Y+rand(K,d)*kick-kick/2;
                end
                D=cross_dis(X,Y);
                U= exp(-B*D);
                S=sum(U,2);
                ind_zero=find(S < ep);
                S(ind_zero)=10^-6;
                n_empty_node=length(ind_zero);
                Q=U./(S*ones(1,K));
                stability=mean(sum(Q.^2,2));
                E=mean(sum(Q.*D.^2,2));
                stability=stability*K/(K-n_empty_node);
                for k=1:K
                    a=sum(Q(:,k));
                    b=sum(X.*( Q(:,k)*ones(1,d)));
                    if a > 0
                    Y(k,:) = b/a;
                    else
                        Y(k,:) = mean_x;
                    end
                end
                DD=eye(K)+cross_dis(Y,Y);
                if stability > 1/K*2
                for k=1:K
                    ind=find(DD(k,:) < ep);
                    ind = ind(find(ind > k));
                    if length(ind) >= 1
                    %Y(ind,:)=Y(ind,:)+rand(length(ind),d)*kick-kick/2;
                    Y(ind,:)=ones(length(ind),1) * mean_x+rand(length(ind),d)*kick-kick/2;

                    end
                end
                end
                if mod(loop,50)==0 
                fprintf('B %f sta %f E %f n %d\n',B,stability,E,n_empty_node);
                end
                if stability > 0.995 
                    HC=1; 
                end    
                B=B/0.995;
            end
            obj.localCenters = Y;
            obj.memberships = Q;
        end
        function D=cross_dis(X,Y)
            K=size(Y,1);N=size(X,1);
            A=sum(X.^2,2)*ones(1,K);
            C=ones(N,1)*sum(Y.^2,2)';
            B=X*Y';
            D=sqrt(A-2*B+C);
        end
        

        function [mm_dis dd]=calMeanDis(obj)
            if obj.withSourceData == 1
                X=obj.sourceData;
                Y=obj.localCenters;
                D=cross_dis(X,Y);
                [v ind]=min(D');
                m = 0;
                for i=1:size(Y,1)
                    hit=find(ind==i);
                    if length(hit) > 0
                        dd(i)=mean(v(hit));
                        m=m+sum(v(hit));
                    else
                        dd(i)=0;
                    end
                end
                figure
                histogram(dd,100);
                fprintf('meanDis = %f \n', m/(length(ind)));
            else
                fprintf('no meanDis due to no source data\n');
            end
            mm_dis =m/(length(ind));
        end
        
        function    obj=adjustSplitting(obj)
            assert(obj.withSourceData==1);
            X = obj.sourceData;
            Y= obj.localCenters;
            D=cross_dis(X,Y);
            [v ind]=min(D');
            [mm_dis dd] =calMeanDis(obj);
            TF = isoutlier(dd);
            center_out=find(TF==1);
            XX=[];cc=0;
            Y2=[];
            for i=1:length(center_out)
                x_ind=find(ind==center_out(i));
                if length(x_ind)>=1
        
                    XX=[XX; X(x_ind,:)];
                    X1=X(x_ind,:);
                    [cidx,ctrs]=kmeans(X1,2);
                    Y2=[Y2;ctrs];
                    cc=cc+1;
                end
            end
             figure
            plot3(XX(:,1),XX(:,2),XX(:,3),'g.'); hold on
            plot3(Y2(:,1),Y2(:,2),Y2(:,3),'rx');

            Y3=[];
            for j=1:size(Y,1)
                k=find(center_out==j);
                if sum(k)==0
                    Y3=[Y3;Y(j,:)];
                end
            end
            Y3=[Y3;Y2];
            obj.localCenters = Y3;
        end

    end
end

